using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using TIS.Imaging;

namespace Creating_an_Overlay
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private Form _sinkDisplay;
        private FrameQueueSink _sink;

        private void Form1_Load( object sender, EventArgs e )
        {
            //摜Xg[ɂOverlayBitmapIuWFNg̈ʒuRg[
            icImagingControl1.OverlayBitmapPosition = TIS.Imaging.PathPositions.Device;
            //͂ꂽt[擾閳֐gRGB32̂ݎ󂯓FrameQueueSink
            _sink = new TIS.Imaging.FrameQueueSink( (img) => { return ShowImage( img ); }, new FrameType( MediaSubtypes.RGB32 ), 5 );
            //sinkɎ󂯓n
            icImagingControl1.Sink = _sink;

            chkPPDevice.Checked = true;
            chkPPSink.Checked = false;
            chkPPDisplay.Checked = false;
            btnBestFit.Checked = true;
        }

        private TIS.Imaging.FrameQueuedResult ShowImage( IFrameQueueBuffer buffer )
        {
            if( _sinkDisplay != null && !_sinkDisplay.IsDisposed )
            {
                // rbg}bṽRs[쐬
                _sinkDisplay.BackgroundImage = buffer.CreateBitmapCopy();
            }
            return FrameQueuedResult.ReQueue;
        }

        /// <summary>
        /// cmdDevice_Click
        ///
        /// foCXI_CAO\ACuXg[JnB
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
		//<<selectdevice
        private void cmdDevice_Click( object sender, EventArgs e )
        {
            cmdStartStop.Text = "Start";

            bool wasLive = icImagingControl1.LiveVideoRunning;
            if( wasLive )
                icImagingControl1.LiveStop();

            icImagingControl1.ShowDeviceSettingsDialog();

            if( icImagingControl1.DeviceValid )
            {
                if( wasLive )
                {
                    icImagingControl1.LiveStart();
                    cmdStartStop.Text = "Stop";
                }

                cmdStartStop.Enabled = true;
                cmdSettings.Enabled = true;
            }
        }
        //>>

        /// <summary>
        /// vpeB _CAO\āAJƃrfĨvpeB𒲐܂B
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        //<<imagesettings
        private void cmdSettings_Click( object sender, EventArgs e )
        {
            if( icImagingControl1.DeviceValid )
            {
                icImagingControl1.ShowPropertyDialog();
            }
        }
        //>>

        /// <summary>
        /// CuXg[̊JnƃXgbv
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        //<<livevideo
        private void cmdStartStop_Click( object sender, EventArgs e )
        {
            if( icImagingControl1.LiveVideoRunning )
            {
                icImagingControl1.LiveStop();
                cmdStartStop.Text = "Start";
            }
            else
            {
                if( icImagingControl1.DeviceValid )
                {
                    icImagingControl1.LiveStart();
                    cmdStartStop.Text = "Stop";
                }
            }
        }
        //>>

        /// <summary>
        /// SetupOverlay		
        /// OverlayBitmap IuWFNgLɂA
        /// dropOutColor (}[^) ݒ肵āA̐FœhԂ܂B
        /// </summary>
        /// <param name="ob"></param>
        //<<SetupOverlay
        private void SetupOverlay( TIS.Imaging.OverlayBitmap ob )
        {
            // `p̃I[o[Crbg}bv摜Lɂ
            ob.Enable = true;

            // I[o[Cŕ\F}[^Fɂ
            ob.DropOutColor = Color.Magenta;

            // I[o[Crbg}bv摜hbvAEg J[œhԂ
            ob.Fill( ob.DropOutColor );

            // eLXg̐F͐ԐFŕ\
            ob.FontTransparent = true;
            ob.DrawText( Color.Red, 10, 10, "IC Imaging Control 3.5" );
        }
        //>>

        /// <summary>
        /// tB^ Ot̏łA
        /// I[o[Crbg}bv摜ɃeLXg܂B
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        //<<liveprepared
        private void icImagingControl1_LivePrepared( object sender, EventArgs e )
        {
            if( icImagingControl1.DeviceValid )
            {
                if( (icImagingControl1.OverlayBitmapPosition & PathPositions.Device) != 0 )
                {
                    SetupOverlay( icImagingControl1.OverlayBitmapAtPath[PathPositions.Device] );

                    // foCX I[o[CɍWn\
                    DrawCoordinatesystem( icImagingControl1.OverlayBitmapAtPath[PathPositions.Device] );

                    // I[o[C{bNX`
                    DrawOverlayInfo( icImagingControl1.OverlayBitmapAtPath[PathPositions.Device] );
                }

                if( (icImagingControl1.OverlayBitmapPosition & PathPositions.Sink) != 0 )
                {
                    SetupOverlay( icImagingControl1.OverlayBitmapAtPath[PathPositions.Sink] );

                    // I[o[C{bNX`
                    DrawOverlayInfo( icImagingControl1.OverlayBitmapAtPath[PathPositions.Sink] );
                }

                if( (icImagingControl1.OverlayBitmapPosition & PathPositions.Display) != 0 )
                {
                    SetupOverlay( icImagingControl1.OverlayBitmapAtPath[PathPositions.Display] );

                    // rbg}bv t@CǂݍŁAfBXvC I[o[Cɕ\
                    ShowBitmap( icImagingControl1.OverlayBitmapAtPath[PathPositions.Display] );

                    // I[o[C{bNX`
                    DrawOverlayInfo( icImagingControl1.OverlayBitmapAtPath[PathPositions.Display] );
                }
            }
        }
        //>>

        /// <summary>
        /// I[oC镶ƐF	 
        /// </summary>
        /// <param name="ob"></param>
        private void DrawOverlayInfo( OverlayBitmap ob )
        {
            switch( ob.PathPosition )
            {
            case PathPositions.Device:
                ob.DrawFrameRect( Color.Red, 90, 90, 200, 130 );
                ob.DrawText( Color.Red, 100, 100, "Device Overlay" );
                break;
            case PathPositions.Sink:
                ob.DrawFrameRect( Color.Red, 390, 90, 500, 130 );
                ob.DrawText( Color.Red, 400, 100, "Sink Overlay" );
                break;
            case PathPositions.Display:
                ob.DrawFrameRect( Color.Red, 90, 290, 200, 330 );
                ob.DrawText( Color.Red, 100, 300, "Display Overlay" );
                break;
            }
        }

        /// <summary>
        /// DrawCoordinatesystem
        /// I[o[CɍWʂ`悷
        /// </summary>
        /// <param name="ob"></param>
		//<<coordinate
        private void DrawCoordinatesystem( TIS.Imaging.OverlayBitmap ob )
        {
            // Calculate the center of the video image.
            int Col = GetVideoDimension().Width / 2;
            int Row = GetVideoDimension().Height / 2;

            Font OldFont = ob.Font;
            ob.Font = new Font( "Arial", 8 );

            ob.DrawLine( Color.Red, Col, 0, Col, GetVideoDimension().Height );
            ob.DrawLine( Color.Red, 0, Row, GetVideoDimension().Width, Row );

            for( int i = 0; i < Row; i += 20 )
            {
                ob.DrawLine( Color.Red, Col - 5, Row - i, Col + 5, Row - i );
                ob.DrawLine( Color.Red, Col - 5, Row + i, Col + 5, Row + i );
                if( i > 0 )
                {
                    ob.DrawText( Color.Red, Col + 10, Row - i - 7, string.Format( "{0}", i / 10 ) );
                    ob.DrawText( Color.Red, Col + 10, Row + i - 7, string.Format( "{0}", -i / 10 ) );
                }
            }

            for( int i = 0; i < Col; i += 20 )
            {
                ob.DrawLine( Color.Red, Col - i, Row - 5, Col - i, Row + 5 );
                ob.DrawLine( Color.Red, Col + i, Row - 5, Col + i, Row + 5 );
                if( i > 0 )
                {
                    ob.DrawText( Color.Red, Col + i - 5, Row - 17, string.Format( "{0}", i / 10 ) );
                    ob.DrawText( Color.Red, Col - i - 10, Row - 17, string.Format( "{0}", -i / 10 ) );
                }
            }

            ob.Font = OldFont;
        }
        //>>

        /// <summary>
        ///I[o[CXVCxgB
        ///t[͕ϐ FrameCount ŃJEgA 
        ///FrameCount ́A㏸Op``悵ăt[ JEg
        ///\邽߂Ɏgp܂B 
        ///FrameCount  25 傫ꍇA`悳ꂽOp`
        ///hbvAEg J[œhԂꂽlp`
        ///`悷邱Ƃɂč폜܂B
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        //<<overlayupdate
        private void icImagingControl1_OverlayUpdate( object sender, TIS.Imaging.ICImagingControl.OverlayUpdateEventArgs e )
        {
            TIS.Imaging.OverlayBitmap ob = e.overlay;

            var info = icImagingControl1.DriverFrameDropInformation;

            int frameCount = (int)info.FramesDelivered;

            int lineIndex = frameCount % 25;
            if( lineIndex == 0 )
            {
                ob.DrawSolidRect( ob.DropOutColor, 10, GetVideoDimension().Height - 70, 62, GetVideoDimension().Height - 9 );
            }

            ob.DrawLine( Color.Yellow, lineIndex * 2 + 10,
                                            GetVideoDimension().Height - 10,
                                            lineIndex * 2 + 10,
                                            GetVideoDimension().Height - 10 - lineIndex );

            //݂̃t[ԍo͂܂B
            //wiF݂̃hbvAEgFɐݒ肵AtHgsɂ
            ob.FontBackColor = ob.DropOutColor;
            ob.FontTransparent = false;

            //݂̃tHgZ[u܂B
            Font OldFont = ob.Font;

            // eLXg`
            ob.Font = new Font( "Arial", 8 );
            ob.DrawText( Color.Yellow, 70, GetVideoDimension().Height - 19, frameCount.ToString() );

            // ȑOɎgptHg𕜌
            ob.Font = OldFont;
        }
        //>>

        /// <summary>
        /// Timer1_Tick

        /// ^C}[ Cxgł́ACu rfI Xg[Ɍݎ`悳܂B
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        //<<timer
        private void timer1_Tick( object sender, EventArgs e )
        {
            TIS.Imaging.OverlayBitmap ob = icImagingControl1.OverlayBitmapAtPath[TIS.Imaging.PathPositions.Device];

            if( icImagingControl1.LiveVideoRunning )
            {
                // Save the current font.
                Font OldFont = ob.Font;

                ob.Font = new Font( "Arial", 14, FontStyle.Bold );

                // rfI EBhE̍ɎԂ`
                int Col = GetVideoDimension().Width - 81;
                int Row = GetVideoDimension().Height - 20;

                // wiFƕ`惂[hݒ
                ob.FontTransparent = false;
                ob.FontBackColor = Color.Black;

                // ݎ𔒐Fŕ`B
                ob.DrawText( Color.White, Col, Row, DateTime.Now.ToString( "T" ) );

                // OɎgptHgۑ
                ob.Font = OldFont;
            }
        }
        //>>

        /// <summary>
        /// ̃Tu[`́AOverlayBitmap.GetGraphics gpāA
        /// CuXg[̃t@Crbg}bv`悷@Ă܂B
        /// wiF}[^ł邽߁Arbg}bv̓Cu\
        /// ŕ`悳܂
        /// mFɂ́A摜 "Hardware.BMP"  "Paint.exe" œǂݍł)B 
        /// }[^́Aݐݒ肳ĂhbvAEg J[łB
        /// </summary>
        /// <param name="ob"></param>
        //<<bitblt
        private void ShowBitmap( TIS.Imaging.OverlayBitmap ob )
        {
            try
            {
                // ŊȒPɃANZXł悤ɁAhardware.bmp vWFNg̃\[XƂĒǉ
                var bmp = Creating_an_Overlay.Properties.Resources.hardware;

                // vZāAImaging Control ̉EɃrbg}bv\
                int col = GetVideoDimension().Width - 5 - bmp.Width;

                // OverlayBitmap  Graphics IuWFNg擾
                Graphics g = ob.GetGraphics();

                // `
                g.DrawImage( bmp, col, 5 );

                // `悪IOtBbNX
                ob.ReleaseGraphics( g );
            }
            catch( Exception Ex )
            {
                MessageBox.Show( "File not found: " + Ex.Message );
            }
        }
        //>>

        /// <summary>
        /// w肳ꂽpXʒũI[o[C rbg}bvL܂͖ɂ܂B
        /// </summary>
        /// <param name="pos"></param>
        /// <param name="enabled"></param>
        //<<setpathpos
        private void EnableOverlayBitmapAtPath( PathPositions pos, bool enabled )
        {
            bool wasLive = icImagingControl1.LiveVideoRunning;
            if( wasLive )
                icImagingControl1.LiveStop();

            PathPositions oldPos = icImagingControl1.OverlayBitmapPosition;
            if( enabled )
                icImagingControl1.OverlayBitmapPosition = oldPos | pos;
            else
                icImagingControl1.OverlayBitmapPosition = oldPos & ~pos;

            if( wasLive )
                icImagingControl1.LiveStart();
        }
        //>>

        private void chkPPDevice_CheckedChanged( object sender, EventArgs e )
        {
            EnableOverlayBitmapAtPath( PathPositions.Device, chkPPDevice.Checked );
        }

        private void chkPPSink_CheckedChanged( object sender, EventArgs e )
        {
            EnableOverlayBitmapAtPath( PathPositions.Sink, chkPPSink.Checked );

            if( chkPPSink.Checked )
            {
                if( _sinkDisplay == null || _sinkDisplay.IsDisposed )
                {
                    _sinkDisplay = new Form();
                    _sinkDisplay.Text = "Sink";
                }

                if( icImagingControl1.DeviceValid )
                {
                    Size d = _sinkDisplay.Size - _sinkDisplay.ClientSize;

                    _sinkDisplay.Width = GetVideoDimension().Width + d.Width;
                    _sinkDisplay.Height = GetVideoDimension().Height + d.Height;
                }

                _sinkDisplay.Show();
            }
        }

        private void chkPPDisplay_CheckedChanged( object sender, EventArgs e )
        {
            EnableOverlayBitmapAtPath( PathPositions.Display, chkPPDisplay.Checked );
        }

        private Size GetVideoDimension()
        {
            return icImagingControl1.VideoFormatCurrent.FrameType.Size;
        }

        /// <summary>
        /// ׂẴI[o[C rbg}bṽJ[ [h <mode> ɐݒ肵܂B
        /// </summary>
        /// <param name="mode"></param>
        private void SetOverlayBitmapColorModes( OverlayColorModes mode )
        {
            bool wasLive = icImagingControl1.LiveVideoRunning;
            if( wasLive )
                icImagingControl1.LiveStop();

            icImagingControl1.OverlayBitmapAtPath[PathPositions.Device].ColorMode = mode;
            icImagingControl1.OverlayBitmapAtPath[PathPositions.Display].ColorMode = mode;
            icImagingControl1.OverlayBitmapAtPath[PathPositions.Sink].ColorMode = mode;

            if( wasLive )
                icImagingControl1.LiveStart();
        }

        private void btnColor_CheckedChanged( object sender, EventArgs e )
        {
            //J[overlay bitmap tH[}bgłB
            //I[oCɃJ[̐eLXg`Ƃł܂B
            if ( btnColor.Checked )
                SetOverlayBitmapColorModes( OverlayColorModes.Color );
        }

        private void btnGrayscale_CheckedChanged( object sender, EventArgs e )
        {
            //O[XP[overlay bitmap tH[}bgłB
            //eLXg̓O[XP[ł`܂B
            if ( btnGrayscale.Checked )
                SetOverlayBitmapColorModes( OverlayColorModes.Grayscale );
        }

        private void btnBestFit_CheckedChanged( object sender, EventArgs e )
        {
            //overlay bitmaptH[}bg͉摜Xg[ɍ킹čœKȂ̂I܂
            if ( btnBestFit.Checked )
                SetOverlayBitmapColorModes( OverlayColorModes.BestFit );
        }

        private void Form1_FormClosing( object sender, FormClosingEventArgs e )
        {
            if( _sinkDisplay != null && !_sinkDisplay.IsDisposed )
            {
                _sinkDisplay.Close();
            }
        }





    }
    //>>
}